"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccountBalanceDeltaRawMapper = exports.BalanceobsvRawMapper = exports.AccountBalanceDeltaMongoMapper = exports.BalanceobsvMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const aw_antelope_1 = require("@alien-worlds/aw-antelope");
const entities_1 = require("../../domain/entities");
class BalanceobsvMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('accountBalanceDeltas', {
            key: 'account_balance_deltas',
            mapper: (values) => values.map(value => new AccountBalanceDeltaMongoMapper().fromEntity(value)),
        });
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { account_balance_deltas, dac_id, _id, ...rest } = mongoModel;
        return entities_1.Balanceobsv.create(account_balance_deltas?.map(value => new AccountBalanceDeltaMongoMapper().toEntity(value)) || [], dac_id || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.BalanceobsvMongoMapper = BalanceobsvMongoMapper;
class AccountBalanceDeltaMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('account', {
            key: 'account',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('balanceDelta', {
            key: 'balance_delta',
            mapper: (value) => new aw_antelope_1.AssetMongoMapper().fromEntity(value),
        });
    }
    toEntity(mongoModel) {
        const { account, balance_delta, _id, ...rest } = mongoModel;
        return entities_1.AccountBalanceDelta.create(account || '', balance_delta ? new aw_antelope_1.AssetMongoMapper().toEntity(balance_delta) : aw_antelope_1.Asset.getDefault(), _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.AccountBalanceDeltaMongoMapper = AccountBalanceDeltaMongoMapper;
class BalanceobsvRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { account_balance_deltas, dac_id, ...rest } = rawModel;
        return entities_1.Balanceobsv.create(account_balance_deltas?.map(value => new AccountBalanceDeltaRawMapper().toEntity(value)) || [], dac_id || '', undefined, rest);
    }
}
exports.BalanceobsvRawMapper = BalanceobsvRawMapper;
class AccountBalanceDeltaRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { account, balance_delta, ...rest } = rawModel;
        return entities_1.AccountBalanceDelta.create(account || '', balance_delta ? new aw_antelope_1.AssetRawMapper().toEntity(balance_delta) : aw_antelope_1.Asset.getDefault(), undefined, rest);
    }
}
exports.AccountBalanceDeltaRawMapper = AccountBalanceDeltaRawMapper;
