"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithdrawcaneRawMapper = exports.WithdrawcaneMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class WithdrawcaneMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('cand', {
            key: 'cand',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { cand, dac_id, _id, ...rest } = mongoModel;
        return entities_1.Withdrawcane.create(cand || '', dac_id || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.WithdrawcaneMongoMapper = WithdrawcaneMongoMapper;
class WithdrawcaneRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { cand, dac_id, ...rest } = rawModel;
        return entities_1.Withdrawcane.create(cand || '', dac_id || '', undefined, rest);
    }
}
exports.WithdrawcaneRawMapper = WithdrawcaneRawMapper;
