"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CandpermsRawMapper = exports.CandpermsMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class CandpermsMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('cand', {
            key: 'cand',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('permission', {
            key: 'permission',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { cand, permission, _id, ...rest } = mongoModel;
        return entities_1.Candperms.create(cand || '', permission || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.CandpermsMongoMapper = CandpermsMongoMapper;
class CandpermsRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { cand, permission, ...rest } = rawModel;
        return entities_1.Candperms.create(cand || '', permission || '', undefined, rest);
    }
}
exports.CandpermsRawMapper = CandpermsRawMapper;
